// Code generated by bpf2go; DO NOT EDIT.
// +build armbe arm64be mips mips64 mips64p32 ppc64 s390 s390x sparc sparc64

package main

import (
	"bytes"
	"fmt"
	"io"

	"github.com/cilium/ebpf"
)

type KProbeExampleSpecs struct {
	ProgramKprobeExecve *ebpf.ProgramSpec `ebpf:"kprobe_execve"`
	MapKprobeMap        *ebpf.MapSpec     `ebpf:"kprobe_map"`
}

func NewKProbeExampleSpecs() (*KProbeExampleSpecs, error) {
	reader := bytes.NewReader(_KProbeExampleBytes)
	spec, err := ebpf.LoadCollectionSpecFromReader(reader)
	if err != nil {
		return nil, fmt.Errorf("can't load KProbeExample: %w", err)
	}

	specs := new(KProbeExampleSpecs)
	if err := spec.Assign(specs); err != nil {
		return nil, fmt.Errorf("can't assign KProbeExample: %w", err)
	}

	return specs, nil
}

func (s *KProbeExampleSpecs) CollectionSpec() *ebpf.CollectionSpec {
	return &ebpf.CollectionSpec{
		Programs: map[string]*ebpf.ProgramSpec{
			"kprobe_execve": s.ProgramKprobeExecve,
		},
		Maps: map[string]*ebpf.MapSpec{
			"kprobe_map": s.MapKprobeMap,
		},
	}
}

func (s *KProbeExampleSpecs) Load(opts *ebpf.CollectionOptions) (*KProbeExampleObjects, error) {
	var objs KProbeExampleObjects
	if err := s.CollectionSpec().LoadAndAssign(&objs, opts); err != nil {
		return nil, err
	}
	return &objs, nil
}

func (s *KProbeExampleSpecs) Copy() *KProbeExampleSpecs {
	return &KProbeExampleSpecs{
		ProgramKprobeExecve: s.ProgramKprobeExecve.Copy(),
		MapKprobeMap:        s.MapKprobeMap.Copy(),
	}
}

type KProbeExampleObjects struct {
	ProgramKprobeExecve *ebpf.Program `ebpf:"kprobe_execve"`
	MapKprobeMap        *ebpf.Map     `ebpf:"kprobe_map"`
}

func (o *KProbeExampleObjects) Close() error {
	for _, closer := range []io.Closer{
		o.ProgramKprobeExecve,
		o.MapKprobeMap,
	} {
		if err := closer.Close(); err != nil {
			return err
		}
	}
	return nil
}

// Do not access this directly.
var _KProbeExampleBytes = []byte("\x7f\x45\x4c\x46\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\xf7\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x12\xb0\x00\x00\x00\x00\x00\x40\x00\x00\x00\x00\x00\x40\x00\x16\x00\x01\xb7\x10\x00\x00\x00\x00\x00\x00\x63\xa1\xff\xfc\x00\x00\x00\x00\xb7\x60\x00\x00\x00\x00\x00\x01\x7b\xa6\xff\xf0\x00\x00\x00\x00\xbf\x2a\x00\x00\x00\x00\x00\x00\x07\x20\x00\x00\xff\xff\xff\xfc\x18\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x85\x00\x00\x00\x00\x00\x00\x01\x55\x00\x00\x09\x00\x00\x00\x00\xbf\x2a\x00\x00\x00\x00\x00\x00\x07\x20\x00\x00\xff\xff\xff\xfc\xbf\x3a\x00\x00\x00\x00\x00\x00\x07\x30\x00\x00\xff\xff\xff\xf0\x18\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb7\x40\x00\x00\x00\x00\x00\x00\x85\x00\x00\x00\x00\x00\x00\x02\x05\x00\x00\x01\x00\x00\x00\x00\xdb\x06\x00\x00\x00\x00\x00\x00\xb7\x00\x00\x00\x00\x00\x00\x00\x95\x00\x00\x00\x00\x00\x00\x00\x44\x75\x61\x6c\x20\x4d\x49\x54\x2f\x47\x50\x4c\x00\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00\x04\x00\x00\x00\x08\x00\x00\x00\x01\x00\x00\x00\x00\x00\x62\x70\x66\x2f\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x61\x6d\x70\x6c\x65\x2e\x63\x00\x2e\x00\x5f\x5f\x6c\x69\x63\x65\x6e\x73\x65\x00\x63\x68\x61\x72\x00\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\x00\x6b\x70\x72\x6f\x62\x65\x5f\x6d\x61\x70\x00\x74\x79\x70\x65\x00\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x69\x6e\x74\x00\x6b\x65\x79\x5f\x73\x69\x7a\x65\x00\x76\x61\x6c\x75\x65\x5f\x73\x69\x7a\x65\x00\x6d\x61\x78\x5f\x65\x6e\x74\x72\x69\x65\x73\x00\x6d\x61\x70\x5f\x66\x6c\x61\x67\x73\x00\x62\x70\x66\x5f\x6d\x61\x70\x5f\x64\x65\x66\x00\x62\x70\x66\x5f\x6d\x61\x70\x5f\x6c\x6f\x6f\x6b\x75\x70\x5f\x65\x6c\x65\x6d\x00\x62\x70\x66\x5f\x6d\x61\x70\x5f\x75\x70\x64\x61\x74\x65\x5f\x65\x6c\x65\x6d\x00\x6c\x6f\x6e\x67\x20\x69\x6e\x74\x00\x6c\x6f\x6e\x67\x20\x6c\x6f\x6e\x67\x20\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x69\x6e\x74\x00\x5f\x5f\x75\x36\x34\x00\x42\x50\x46\x5f\x41\x4e\x59\x00\x42\x50\x46\x5f\x4e\x4f\x45\x58\x49\x53\x54\x00\x42\x50\x46\x5f\x45\x58\x49\x53\x54\x00\x42\x50\x46\x5f\x46\x5f\x4c\x4f\x43\x4b\x00\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x65\x63\x76\x65\x00\x69\x6e\x74\x00\x6b\x65\x79\x00\x5f\x5f\x75\x33\x32\x00\x75\x33\x32\x00\x69\x6e\x69\x74\x76\x61\x6c\x00\x75\x36\x34\x00\x76\x61\x6c\x70\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x20\x00\x02\x30\x9f\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x00\x00\x00\x00\xb0\x00\x02\x7a\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x18\x00\x00\x00\x00\x00\x00\x00\x50\x00\x02\x31\x9f\x00\x00\x00\x00\x00\x00\x00\x50\x00\x00\x00\x00\x00\x00\x00\x98\x00\x02\x7a\x00\x00\x00\x00\x00\x00\x00\x00\x98\x00\x00\x00\x00\x00\x00\x00\xa0\x00\x02\x31\x9f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x48\x00\x00\x00\x00\x00\x00\x00\x90\x00\x01\x50\x00\x00\x00\x00\x00\x00\x00\x98\x00\x00\x00\x00\x00\x00\x00\xa0\x00\x01\x50\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x11\x01\x25\x0e\x13\x05\x03\x0e\x10\x17\x1b\x0e\x11\x01\x12\x06\x00\x00\x02\x34\x00\x03\x0e\x49\x13\x3f\x19\x3a\x0b\x3b\x0b\x02\x18\x00\x00\x03\x01\x01\x49\x13\x00\x00\x04\x21\x00\x49\x13\x37\x0b\x00\x00\x05\x24\x00\x03\x0e\x3e\x0b\x0b\x0b\x00\x00\x06\x24\x00\x03\x0e\x0b\x0b\x3e\x0b\x00\x00\x07\x13\x01\x03\x0e\x0b\x0b\x3a\x0b\x3b\x0b\x00\x00\x08\x0d\x00\x03\x0e\x49\x13\x3a\x0b\x3b\x0b\x38\x0b\x00\x00\x09\x34\x00\x03\x0e\x49\x13\x3a\x0b\x3b\x0b\x00\x00\x0a\x0f\x00\x49\x13\x00\x00\x0b\x15\x01\x49\x13\x27\x19\x00\x00\x0c\x05\x00\x49\x13\x00\x00\x0d\x0f\x00\x00\x00\x0e\x26\x00\x00\x00\x0f\x16\x00\x49\x13\x03\x0e\x3a\x0b\x3b\x0b\x00\x00\x10\x04\x01\x49\x13\x0b\x0b\x3a\x0b\x3b\x0b\x00\x00\x11\x28\x00\x03\x0e\x1c\x0f\x00\x00\x12\x2e\x01\x11\x01\x12\x06\x40\x18\x97\x42\x19\x03\x0e\x3a\x0b\x3b\x0b\x49\x13\x3f\x19\x00\x00\x13\x34\x00\x02\x17\x03\x0e\x3a\x0b\x3b\x0b\x49\x13\x00\x00\x00\x00\x00\x01\xb6\x00\x04\x00\x00\x00\x00\x08\x01\x00\x00\x00\x00\x00\x0c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb0\x02\x00\x00\x00\x00\x00\x00\x00\x3f\x01\x04\x09\x03\x00\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x00\x4b\x04\x00\x00\x00\x52\x0d\x00\x05\x00\x00\x00\x00\x06\x01\x06\x00\x00\x00\x00\x08\x07\x02\x00\x00\x00\x00\x00\x00\x00\x6e\x01\x06\x09\x03\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x14\x02\x39\x08\x00\x00\x00\x00\x00\x00\x00\xb3\x02\x3a\x00\x08\x00\x00\x00\x00\x00\x00\x00\xb3\x02\x3b\x04\x08\x00\x00\x00\x00\x00\x00\x00\xb3\x02\x3c\x08\x08\x00\x00\x00\x00\x00\x00\x00\xb3\x02\x3d\x0c\x08\x00\x00\x00\x00\x00\x00\x00\xb3\x02\x3e\x10\x00\x05\x00\x00\x00\x00\x07\x04\x09\x00\x00\x00\x00\x00\x00\x00\xc5\x03\x2a\x0a\x00\x00\x00\xca\x0b\x00\x00\x00\xda\x0c\x00\x00\x00\xda\x0c\x00\x00\x00\xdb\x00\x0d\x0a\x00\x00\x00\xe0\x0e\x09\x00\x00\x00\x00\x00\x00\x00\xec\x03\x40\x0a\x00\x00\x00\xf1\x0b\x00\x00\x01\x0b\x0c\x00\x00\x00\xda\x0c\x00\x00\x00\xdb\x0c\x00\x00\x00\xdb\x0c\x00\x00\x01\x12\x00\x05\x00\x00\x00\x00\x05\x08\x0f\x00\x00\x01\x1d\x00\x00\x00\x00\x04\x0c\x05\x00\x00\x00\x00\x07\x08\x10\x00\x00\x00\xb3\x04\x04\x3a\x11\x00\x00\x00\x00\x00\x11\x00\x00\x00\x00\x01\x11\x00\x00\x00\x00\x02\x11\x00\x00\x00\x00\x04\x00\x12\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb0\x01\x5a\x00\x00\x00\x00\x01\x0e\x00\x00\x01\x8c\x13\x00\x00\x00\x00\x00\x00\x00\x00\x01\x0f\x00\x00\x01\x93\x13\x00\x00\x00\x38\x00\x00\x00\x00\x01\x10\x00\x00\x01\xa9\x13\x00\x00\x00\x84\x00\x00\x00\x00\x01\x10\x00\x00\x01\xb4\x00\x05\x00\x00\x00\x00\x05\x04\x0f\x00\x00\x01\x9e\x00\x00\x00\x00\x04\x11\x0f\x00\x00\x00\xb3\x00\x00\x00\x00\x04\x0a\x0f\x00\x00\x01\x12\x00\x00\x00\x00\x04\x13\x0a\x00\x00\x01\xa9\x00\xeb\x9f\x01\x00\x00\x00\x00\x18\x00\x00\x00\x00\x00\x00\x01\x08\x00\x00\x01\x08\x00\x00\x01\xb4\x00\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00\x01\x01\x00\x00\x00\x00\x00\x00\x04\x01\x00\x00\x20\x00\x00\x00\x05\x0c\x00\x00\x01\x00\x00\x00\x01\x00\x00\x01\x31\x01\x00\x00\x00\x00\x00\x00\x01\x01\x00\x00\x08\x00\x00\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00\x06\x00\x00\x00\x0d\x00\x00\x01\x36\x01\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00\x20\x00\x00\x01\x4a\x0e\x00\x00\x00\x00\x00\x00\x05\x00\x00\x00\x01\x00\x00\x01\x54\x04\x00\x00\x05\x00\x00\x00\x14\x00\x00\x01\x60\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x01\x65\x00\x00\x00\x09\x00\x00\x00\x20\x00\x00\x01\x6e\x00\x00\x00\x09\x00\x00\x00\x40\x00\x00\x01\x79\x00\x00\x00\x09\x00\x00\x00\x60\x00\x00\x01\x85\x00\x00\x00\x09\x00\x00\x00\x80\x00\x00\x01\x8f\x01\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00\x20\x00\x00\x01\x9c\x0e\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x01\x00\x00\x01\xa7\x0f\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x0d\x00\x00\x01\xaf\x0f\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x14\x00\x69\x6e\x74\x00\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x65\x63\x76\x65\x00\x6b\x70\x72\x6f\x62\x65\x2f\x5f\x5f\x78\x36\x34\x5f\x73\x79\x73\x5f\x65\x78\x65\x63\x76\x65\x00\x2e\x2f\x62\x70\x66\x2f\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x61\x6d\x70\x6c\x65\x2e\x63\x00\x69\x6e\x74\x20\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x65\x63\x76\x65\x28\x29\x20\x7b\x00\x20\x20\x20\x20\x75\x33\x32\x20\x6b\x65\x79\x20\x3d\x20\x30\x3b\x00\x20\x20\x20\x20\x75\x36\x34\x20\x69\x6e\x69\x74\x76\x61\x6c\x20\x3d\x20\x31\x2c\x20\x2a\x76\x61\x6c\x70\x3b\x00\x20\x20\x20\x20\x76\x61\x6c\x70\x20\x3d\x20\x62\x70\x66\x5f\x6d\x61\x70\x5f\x6c\x6f\x6f\x6b\x75\x70\x5f\x65\x6c\x65\x6d\x28\x26\x6b\x70\x72\x6f\x62\x65\x5f\x6d\x61\x70\x2c\x20\x26\x6b\x65\x79\x29\x3b\x00\x20\x20\x20\x20\x69\x66\x20\x28\x21\x76\x61\x6c\x70\x29\x20\x7b\x00\x20\x20\x20\x20\x20\x20\x20\x20\x62\x70\x66\x5f\x6d\x61\x70\x5f\x75\x70\x64\x61\x74\x65\x5f\x65\x6c\x65\x6d\x28\x26\x6b\x70\x72\x6f\x62\x65\x5f\x6d\x61\x70\x2c\x20\x26\x6b\x65\x79\x2c\x20\x26\x69\x6e\x69\x74\x76\x61\x6c\x2c\x20\x42\x50\x46\x5f\x41\x4e\x59\x29\x3b\x00\x20\x20\x20\x20\x5f\x5f\x73\x79\x6e\x63\x5f\x66\x65\x74\x63\x68\x5f\x61\x6e\x64\x5f\x61\x64\x64\x28\x76\x61\x6c\x70\x2c\x20\x31\x29\x3b\x00\x7d\x00\x63\x68\x61\x72\x00\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\x00\x5f\x5f\x6c\x69\x63\x65\x6e\x73\x65\x00\x62\x70\x66\x5f\x6d\x61\x70\x5f\x64\x65\x66\x00\x74\x79\x70\x65\x00\x6b\x65\x79\x5f\x73\x69\x7a\x65\x00\x76\x61\x6c\x75\x65\x5f\x73\x69\x7a\x65\x00\x6d\x61\x78\x5f\x65\x6e\x74\x72\x69\x65\x73\x00\x6d\x61\x70\x5f\x66\x6c\x61\x67\x73\x00\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x69\x6e\x74\x00\x6b\x70\x72\x6f\x62\x65\x5f\x6d\x61\x70\x00\x6c\x69\x63\x65\x6e\x73\x65\x00\x6d\x61\x70\x73\x00\xeb\x9f\x01\x00\x00\x00\x00\x20\x00\x00\x00\x00\x00\x00\x00\x14\x00\x00\x00\x14\x00\x00\x00\xac\x00\x00\x00\xc0\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x13\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x00\x10\x00\x00\x00\x13\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x00\x00\x42\x00\x00\x38\x00\x00\x00\x00\x08\x00\x00\x00\x2b\x00\x00\x00\x58\x00\x00\x3c\x09\x00\x00\x00\x18\x00\x00\x00\x2b\x00\x00\x00\x69\x00\x00\x40\x09\x00\x00\x00\x28\x00\x00\x00\x2b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x30\x00\x00\x00\x2b\x00\x00\x00\x85\x00\x00\x48\x0c\x00\x00\x00\x48\x00\x00\x00\x2b\x00\x00\x00\xb8\x00\x00\x4c\x09\x00\x00\x00\x58\x00\x00\x00\x2b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x70\x00\x00\x00\x2b\x00\x00\x00\xc9\x00\x00\x50\x09\x00\x00\x00\x98\x00\x00\x00\x2b\x00\x00\x01\x0c\x00\x00\x5c\x05\x00\x00\x00\xa0\x00\x00\x00\x2b\x00\x00\x01\x2f\x00\x00\x68\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x00\x01\x7a\x52\x00\x08\x7c\x0b\x01\x0c\x00\x00\x00\x00\x00\x00\x18\x00\x00\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb0\x00\x00\x00\x00\x00\x00\x00\xa9\x00\x04\x00\x00\x00\x69\x08\x01\x01\xfb\x0e\x0d\x00\x01\x01\x01\x01\x00\x00\x00\x01\x00\x00\x01\x62\x70\x66\x00\x2e\x2e\x2f\x68\x65\x61\x64\x65\x72\x73\x00\x00\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x61\x6d\x70\x6c\x65\x2e\x63\x00\x01\x00\x00\x62\x70\x66\x5f\x68\x65\x6c\x70\x65\x72\x73\x2e\x68\x00\x02\x00\x00\x62\x70\x66\x5f\x68\x65\x6c\x70\x65\x72\x5f\x64\x65\x66\x73\x2e\x68\x00\x02\x00\x00\x63\x6f\x6d\x6d\x6f\x6e\x2e\x68\x00\x02\x00\x00\x00\x00\x09\x02\x00\x00\x00\x00\x00\x00\x00\x00\x03\x0d\x01\x05\x09\x0a\x21\x2f\x06\x03\x70\x20\x05\x0c\x06\x03\x12\x2e\x05\x09\x3d\x06\x03\x6d\x20\x06\x03\x14\x4a\x06\x03\x6c\x4a\x05\x05\x06\x03\x17\x20\x05\x01\x23\x02\x02\x00\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb8\x04\x00\xff\xf1\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x16\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x27\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x3b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x46\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x4b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x58\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x61\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x6c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x78\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x82\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\x8e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xa2\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xb6\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xbf\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xd6\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xdc\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xe4\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xf0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x00\xfa\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x05\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x17\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x1b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x21\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x25\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x00\x00\x00\x00\x00\x00\x01\x31\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe9\x00\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x98\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe2\x00\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\xa0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x12\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x85\x11\x00\x00\x05\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0d\x00\x00\x00\x77\x12\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb0\x00\x00\x00\x32\x11\x00\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x14\x00\x00\x00\x00\x00\x00\x00\x30\x00\x00\x00\x29\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x70\x00\x00\x00\x29\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x06\x00\x00\x00\x25\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x0c\x00\x00\x00\x02\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x12\x00\x00\x00\x03\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x16\x00\x00\x00\x26\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x1a\x00\x00\x00\x04\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x1e\x00\x00\x00\x23\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x2b\x00\x00\x00\x05\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x37\x00\x00\x00\x27\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x4c\x00\x00\x00\x06\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x53\x00\x00\x00\x07\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x5a\x00\x00\x00\x08\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x66\x00\x00\x00\x29\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x6f\x00\x00\x00\x0f\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x77\x00\x00\x00\x09\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x83\x00\x00\x00\x0b\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x8f\x00\x00\x00\x0c\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x9b\x00\x00\x00\x0d\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\xa7\x00\x00\x00\x0e\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\xb4\x00\x00\x00\x0a\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\xbb\x00\x00\x00\x10\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\xe2\x00\x00\x00\x11\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x0c\x00\x00\x00\x12\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x17\x00\x00\x00\x14\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x1e\x00\x00\x00\x13\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x2d\x00\x00\x00\x15\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x33\x00\x00\x00\x16\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x39\x00\x00\x00\x17\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x3f\x00\x00\x00\x18\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x46\x00\x00\x00\x23\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x01\x54\x00\x00\x00\x19\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x5f\x00\x00\x00\x24\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x63\x00\x00\x00\x1b\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x6e\x00\x00\x00\x24\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x72\x00\x00\x00\x1e\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x7d\x00\x00\x00\x24\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x81\x00\x00\x00\x20\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x8d\x00\x00\x00\x1a\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x98\x00\x00\x00\x1d\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\xa3\x00\x00\x00\x1c\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\xae\x00\x00\x00\x1f\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x27\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x18\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2c\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x50\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x60\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x70\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x90\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa0\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb0\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc0\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd0\x00\x00\x00\x23\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1c\x00\x00\x00\x23\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x76\x00\x00\x00\x23\x00\x00\x00\x01\x28\x27\x29\x00\x2e\x64\x65\x62\x75\x67\x5f\x61\x62\x62\x72\x65\x76\x00\x2e\x74\x65\x78\x74\x00\x2e\x72\x65\x6c\x2e\x42\x54\x46\x2e\x65\x78\x74\x00\x6d\x61\x70\x73\x00\x2e\x64\x65\x62\x75\x67\x5f\x73\x74\x72\x00\x6b\x70\x72\x6f\x62\x65\x5f\x6d\x61\x70\x00\x2e\x72\x65\x6c\x2e\x64\x65\x62\x75\x67\x5f\x69\x6e\x66\x6f\x00\x2e\x6c\x6c\x76\x6d\x5f\x61\x64\x64\x72\x73\x69\x67\x00\x2e\x72\x65\x6c\x6b\x70\x72\x6f\x62\x65\x2f\x5f\x5f\x78\x36\x34\x5f\x73\x79\x73\x5f\x65\x78\x65\x63\x76\x65\x00\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x65\x63\x76\x65\x00\x5f\x5f\x6c\x69\x63\x65\x6e\x73\x65\x00\x2e\x72\x65\x6c\x2e\x64\x65\x62\x75\x67\x5f\x6c\x69\x6e\x65\x00\x2e\x72\x65\x6c\x2e\x65\x68\x5f\x66\x72\x61\x6d\x65\x00\x2e\x64\x65\x62\x75\x67\x5f\x6c\x6f\x63\x00\x6b\x70\x72\x6f\x62\x65\x5f\x65\x78\x61\x6d\x70\x6c\x65\x2e\x63\x00\x2e\x73\x74\x72\x74\x61\x62\x00\x2e\x73\x79\x6d\x74\x61\x62\x00\x2e\x72\x65\x6c\x2e\x42\x54\x46\x00\x4c\x42\x42\x30\x5f\x33\x00\x4c\x42\x42\x30\x5f\x32\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc9\x00\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x11\xbb\x00\x00\x00\x00\x00\x00\x00\xf0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0f\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x5f\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x00\x00\x00\x00\x00\x00\xb0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x5b\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x28\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x15\x00\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x87\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf0\x00\x00\x00\x00\x00\x00\x00\x0d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x22\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x14\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x27\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x30\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x14\x00\x00\x00\x00\x00\x00\x01\x36\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\xad\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x4a\x00\x00\x00\x00\x00\x00\x00\xba\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x04\x00\x00\x00\x00\x00\x00\x00\xdf\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x41\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\xe3\x00\x00\x00\x00\x00\x00\x01\xba\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3d\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0e\x48\x00\x00\x00\x00\x00\x00\x02\x80\x00\x00\x00\x15\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\xdd\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x05\x9d\x00\x00\x00\x00\x00\x00\x02\xd4\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd9\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x10\xc8\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00\x15\x00\x00\x00\x0c\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x19\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x08\x71\x00\x00\x00\x00\x00\x00\x00\xe0\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x15\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x10\xe8\x00\x00\x00\x00\x00\x00\x00\xb0\x00\x00\x00\x15\x00\x00\x00\x0e\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\xa3\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x09\x58\x00\x00\x00\x00\x00\x00\x00\x30\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9f\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x11\x98\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x15\x00\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x93\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x09\x88\x00\x00\x00\x00\x00\x00\x00\xad\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x8f\x00\x00\x00\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x11\xa8\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x15\x00\x00\x00\x12\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x10\x00\x00\x00\x4d\x6f\xff\x4c\x03\x00\x00\x00\x00\x80\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x11\xb8\x00\x00\x00\x00\x00\x00\x00\x03\x00\x00\x00\x15\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd1\x00\x00\x00\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0a\x38\x00\x00\x00\x00\x00\x00\x03\xf0\x00\x00\x00\x01\x00\x00\x00\x27\x00\x00\x00\x00\x00\x00\x00\x08\x00\x00\x00\x00\x00\x00\x00\x18")
